import socket

PORT    = 2334
SIZE    = 32

class Robot_Admin:
    def __init__(self):
        self.s      = None
        self._alive = False
        #Puerto queda abierto en caso de excepción

    def is_alive(self):
        self.comprobar()
        return self._alive
    
    def conectar(self, HOST):
        self.s = socket.create_connection((HOST, PORT), 5)
        self.s.settimeout(None)
        self._alive = True

    def avanzar(self, velocidad=100):
        self.s.send(bytes(f'{f"avanzar {velocidad}":{SIZE}}', "utf-8"))
    def retroceder(self, velocidad=100):
        self.s.send(bytes(f'{f"retroceder {velocidad}":{SIZE}}', "utf-8"))
    def izquierda(self, velocidad=10):
        self.s.send(bytes(f'{f"izquierda {velocidad}":{SIZE}}', "utf-8"))
    def derecha(self, velocidad=10):
        self.s.send(bytes(f'{f"derecha {velocidad}":{SIZE}}', "utf-8"))
    def atacar(self, velocidad=50, rotación=True):
        self.s.send(bytes(f'{f"atacar {velocidad} {int(rotación)}":{SIZE}}', "utf-8"))
    def perdonar(self):
        self.s.send(bytes(f'{"perdonar":{SIZE}}', "utf-8"))
    def apagar(self):
        self.s.send(bytes(f'{"apagar":{SIZE}}', "utf-8"))
    def detener(self):
        self.s.send(bytes(f'{"detener":{SIZE}}', "utf-8"))
    
    def comprobar(self):
        try:
            self.s.send(bytes(f'{"pass":{SIZE}}', "utf-8"))
            self.s.send(bytes(f'{"pass":{SIZE}}', "utf-8"))
        except:
            self._alive = False
    

if __name__ == "__main__":
    # Prueba
    local_ip = "127.0.0.1"
    robot    = None

    print("Robot_Admin")
    robot = Robot_Admin()
    robot.conectar(local_ip)

    while True:
        if robot.is_alive():
            print("Envía 1 para mandar mensaje: ")
            x = input()
            if   "1" == x:
                robot.avanzar("10")
            elif "2" == x:
                robot.retroceder("10")
        else:
            print("¿Deseas reconectarte? [Y/N]")
            x = input().capitalize()
            if   "Y" == x:
                try:
                    robot.conectar(local_ip)
                except:
                    print("Conexión Fallida")
            elif "N" == x:
                break;
